      DOUBLE PRECISION FUNCTION PYTHAG(A,B)
C***BEGIN PROLOGUE  PYTHAG
C***REFER TO  EISDOC
C
C     Finds sqrt(A**2+B**2) without overflow or destructive underflow
C***ROUTINES CALLED  (NONE)
C***END PROLOGUE  PYTHAG
      DOUBLE PRECISION A,B
C
      DOUBLE PRECISION P,Q,R,S,T
C***FIRST EXECUTABLE STATEMENT  PYTHAG
      P = DABS(A)
      IF (DABS(B) .GT. DABS(A)) P = DABS(B)
      Q = DABS(A)
      IF (DABS(B) .LT. DABS(A)) Q = DABS(B)
      IF (Q .EQ. 0.0D0) GO TO 20
   10 CONTINUE
         R = (Q/P)**2
         T = 4.0D0 + R
         IF (T .EQ. 4.0D0) GO TO 20
         S = R/T
         P = P + 2.0D0*P*S
         Q = Q*S
      GO TO 10
   20 PYTHAG = P
      RETURN
      END
