#ifndef PARSEPROC_H
#define PARSEPROC_H

static void   set_defaults(void);
static int    get_cmd_fnams(int,char**),open_par_fil(void),
              get_tokens(void),         get_aggr_key(void),
              get_data_list(void),      proc_end(void);
static char * get_line(void);		
static char * alloc_copy(char *);           
static void   realloc_arrs(void),       realloc_toks(int),
              free_arrs(void),          free_fnam(void),
              chk_fil(char *),          chk_stor(int,int),
              chk_seeds(void);
static int    chk_stat(void),           chk_repeat(void),
              chk_trait(void),          chk_ff(int),
              chk_sel_tr(void),         chk_start_ff(int),
              chk_levels_ff(void),      chk_var(void),
	      chk_covar(void),          chk_covar_i(void),
              chk_sim(int,int),         chk_unlnkd(void),
              chk_map(int,int,int),     chk_locus(int,int),
              chk_means(void),          chk_vari(void);
static SIM  * chk_sim_node(int),      * alloc_sim_node(int);
static UNLNKD*alloc_unlnkd_node(int);
static MAP  * chk_map_node(int,int),  * alloc_map_node(int,int);     
static LOCUS* chk_locus_node(int,int,int),
            * alloc_locus_node(int,int,int),
            * alloc_dflt_locus_node(int,int,int),
            * alloc_locus_nodex(int,int,int);
static MEANS* chk_means_node(int) ,   * alloc_means_node(int);
static FREQ * alloc_frq(void),        * alloc_dflt_frq(void),
            * alloc_frqx(int);
static VARI * chk_vari_node(int,int), * alloc_vari_node(int,int);
static void   alloc_dist(MAP_PTR,int);
static void   stor_sim_data(SIM_PTR,int,int);
static void   stor_unlnkd(int,UNLNKD_PTR);
static void   stor_map_data(MAP_PTR,int,int,int);
static void   stor_frq(FREQ_PTR),
              stor_dflt_frq(FREQ_PTR);
static void   stor_locus_data(int,LOCUS_PTR,FREQ_PTR,int,int),
              stor_dflt_locus_data(int,int,LOCUS_PTR,FREQ_PTR);
static void   stor_mean_data(int,MEANS_PTR);
static void   stor_dflt_mean_data(int,MEANS_PTR);
static void   stor_vari_data(int,VARI_PTR);
static void   stor_dflt_vari_data(int,VARI_PTR);
static void   free_unlnkd(void),        free_dist(MAP_PTR),
              free_freq(LOCUS_PTR);
static int    compar_mkid_d(DIST_PTR,DIST_PTR);
static void   reset_sel_tr(void),       reset_start_ff(int),
	      reset_start_var(int),     reset_start_cov(int),
	      reset_fit_var(int),       reset_fit_cov(int),   
              reset_set_eigen(void);
static void   set_sel_tr(int),          set_start_ff(int),
	      set_start_var(int),       set_start_cor(int),
	      set_start_cov(int),	set_fit_cov(int),         
	      set_set_eigen(void);

static int      max_npar, max_tchar;
static int      ni_par, nk_par, nh_par, nr_par, nx_par, ns_par;
static int    * j_par;
static uint32 * u_par;
static double * d_par;
static char     s_par[MAXLINLEN+1];

#endif /*PARSEPROC_H*/
