
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*       stuff.h:  header file for Stuff/                              */
/*                 this header file includes:                          */
/*                    the current MORGAN version no.                   */
/*                    function prototyes for Stuff/ functions          */
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef STUFF_H
#define STUFF_H 

#include "incs.h"

                                      /*** MORGAN version no. is here ***/
#define MORGVERS "MORGAN Version 2.2"

#define DATASINK "/dev/null"

#define WHERE    __FILE__, __LINE__

GLOBAL int nWarns;                      /*total no. of warnings issued  */


                                        /*function prototypes for       */
                                        /*Stuff/ library:               */
void alloc_chk       (char *, int, void *);
void give_warn       (int, ...);
void give_warn_where (char *, int, int, ...);
void give_err        (int, ...);
void give_err_where  (char *, int, int, ...);
void give_up         (int, ...);
void give_up_where   (char *, int, int, ...);
void print_head      (char *);
void print_tail      (void);
void printhost       (void);
void print_val       (double);
void print_val5      (double);
int  intWid          (int, int);   
int  decWid(double, double, int); 
int  fldWid(double, double, int);

FILE * open_fil      (char *);
FILE * open_ped      (void);
void   copy_fnam     (char *, char *);
FILTAB_PTR get_filent(char *);

#endif  /*STUFF_H*/

