
/* ---------- proc_err:  called by MORGAN programs ------------------ 
 *                       prints warning or error messages
 *                       error codes and messages are in errspars.h
 *
 *							  MAJ Jun 1997 
 */

int proc_err(void)
{
    int i;

    perr = errors + (int) err_typ;
    if (perr->level == 'W')
	++n_warn;
    else
    if (perr->level == 'E')
	++n_err;

    if (perr->tokflg)			/* tokens are printed if known	 */
    {
	fprintf(stderr, "### ");
	for (i = 0; token[i][0] != NUL; ++i)
	    fprintf(stderr, "%s ", token[i]);
	fprintf(stderr, "\n\n   ");
    }
    if (perr->txtflg)                  /* warning or error is printed   */
        fprintf(stderr, perr->msg, err_txt);
    else
        fprintf(stderr, perr->msg);

    fprintf(stderr, "  (%c)\n\n", perr->level);

    if (perr->statflg)			/* correct statement form prnted */
	fprintf(stderr, "    Correct form is:  %s\n\n",
		input_statement[key_ix - 1]);

    fflush(stderr);

    if (perr->level == 'Q')		/* tests for "quit"		 */
	return TRUE;

    if (perr->level == 'F')		/* tests for fatal errors	 */
    {
	err_typ = ERR_FAT;
	if (proc_err())
	    return TRUE;
    }
    if (n_err + n_warn >= MAX_PERR)	/* tests for too many errors	 */
    {
	err_typ = ERR_MAX;
	if (proc_err())
	    return TRUE;
    }
    err_typ = 0;
    return FALSE;
}
