
#include "parsefils.h"

/*
 * proc_fils() calls functions to set parameters for input and
 * output pedigree files.
 */

int proc_fils(void)
{
    if (!test_pedfil())
        if(proc_err())
            return FALSE;

    if (!test_opedfil())
        if(proc_err())
            return FALSE;

    return proc_end();
}

int test_pedfil(void)			/* checks where pedigree file   */ 
{					/* was named		 	*/
					/* checks pedigree size against */
                                        /* limits			*/
                                        /* checks record options        */
                                        /* (order, gender, observed)    */
                                        /* and sets processing parametrs*/
    pft = get_filent(PED);

    if (PedSize <= 0)			/* checks PedSize		*/
         err_typ = ERF_PE0;
    if (!allw_pedsiz)
        allw_pedsiz = pmx->max_ped;
    if (PedSize > allw_pedsiz)
	if (pmx->pcod == 'u')
	    err_typ = ERF_PE1;
	else
	    err_typ = ERF_PE2;

    if (!allw_cmpsiz)
        allw_cmpsiz = pmx->max_cmp;
    if (allw_cmpsiz > PedSize)
        allw_cmpsiz = PedSize;

    if (!allw_obsiz)
        allw_obsiz = pmx->max_obs;
    if (allw_obsiz > PedSize)
        allw_obsiz = PedSize; 

    if (allw_maxnam)			/* sets MaxNames		*/
        MaxNames = allw_maxnam;
    else
        MaxNames = MAX_NAMES;
    
    MaxNCmps = MAX_NCOMPS;		/* sets MaxNCmps		*/

    if (SexIn == UNDEF)			/* checks SexIn and sets SexOp	*/
        SexIn = Y;

    if (SexIn == Y)
    {
        if (SexOp == UNDEF)
            SexOp = CHECK;
    }
    else if (SexIn == N)
    {
        if (SexOp != IGNORE)
            SexOp = ASSIGN;
    }
                                        /* sets SexOut                  */
    if (SexIn == Y  ||  SexOp == ASSIGN) 
        SexOut = Y;

                 			/* checks ObsIn and sets ObsOp	*/
    if (ObsIn == UNDEF)
        ObsIn = N;

    if (ObsIn == Y)
    {
        if (ObsOp == UNDEF)
            ObsOp = USE;  
    }
    else if (ObsIn == N)
    {
        if (ObsOp == UNDEF)
        {
            if (pmx->pcod == 'd')
                ObsOp = ALL;  
            else
                ObsOp = IGNORE;  
        }
    }
                                        /* sets ObsOut                  */
    if (ObsIn == Y || ObsOp == ALL)
        if (pmx->pcod != 'd' || (pmx->pcod == 'd' && AllVarOut))
            ObsOut = Y;

					/* sets DiscardReals		*/
    if (pmx->pcod == 'd')
        DiscardReals = Y;

    else 
        DiscardReals = N;

    StdIn[0] = NAM;			/* sets NStdIn, StdIn[]		*/

    if (parentOrdIn == UNDEF)
        parentOrdIn = PA1ST;

    if (parentOrdIn == PA1ST)
    {
        StdIn[1] = PA;
        StdIn[2] = MA;
    }
    else
    {
        StdIn[1] = MA;
        StdIn[2] = PA;
    }
    NStdIn = 3;

    if (SexIn)
    {
        StdIn[NStdIn] = SEX;
        ++NStdIn;
    }
    if (ObsIn)
    {
        StdIn[NStdIn] = OBS;
        ++NStdIn;
    }
					/* checks NInts, NReals		*/
					/* sets NNInts			*/
    if (NInts == 0 && NReals == 0)
        err_typ = ERF_IPR;

    else if (NInts < NStdIn)
    {
        err_typ = ERF_NIN;
        sprintf(errnumb, "%d", NStdIn );
        err_txt = errnumb;
    }
    else if (NInts < 3 + NFix)
    {
        err_typ = ERF_NIN;
        sprintf(errnumb, "%d", 3 + NFix);
        err_txt = errnumb;
    }
    else if (pmx->pcod != 'd')
    {
        if (NReals < NTraits)
        {
            err_typ = ERF_NRL;
            sprintf(errnumb, "%d", NTraits);
            err_txt = errnumb;
        }
    }
    NNInts = NInts - NStdIn; 

    if (!err_typ)
        return TRUE;
    else
        return FALSE;
}

int test_opedfil(void)
{
    pft = get_filent(OPED);
    if (pmx->pcod == 'd')
        if (!pft->fname)
            err_typ = ERD_OPF;

    StdOut[0] = NAM;			/* sets NStdOut, StdOut[]	*/

    if (parentOrdOut == UNDEF)
        parentOrdOut = parentOrdIn;

    if (parentOrdOut == PA1ST)
    {
        StdOut[1] = PA;
        StdOut[2] = MA;
    }
    else
    {
        StdOut[1] = MA;
        StdOut[2] = PA;
    }
    NStdOut = 3;

    if (SexOut) 
    {
        StdOut[NStdOut] = SEX;
        ++NStdOut;
    }

    if (ObsOut)
    {
        StdOut[NStdOut] = OBS;
        ++NStdOut;
    }

    if (!err_typ)
        return TRUE;
    else
        return FALSE;
}

