    
/*  functions are: 
 *          assignChron()
 *          checkChron()
 *          newChron()
 */

#include "pedchk.h"

void OLDassignChron(void)
{
    int nThisLoop;
    int nChron = 0;
    KEYS_PP ppK;
                                        /* assigns chronological no's   */
                                        /* to founders                  */
    for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
        if ((*ppK)->founder)  
            (*ppK)->chron = ++nChron;

    do {				/* non-founder:			*/
        nThisLoop = 0;			/* tests for ma & pa already	*/
					/* assigned chronological no.	*/ 
        for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
            if (!(*ppK)->chron)
                if ((*(ppKeyTab + (*ppK)->ixMa - 1))->chron &&
                    (*(ppKeyTab + (*ppK)->ixPa - 1))->chron)		
                {
                    (*ppK)->chron = ++nChron;
                    ++nThisLoop;
                }
    } while (nThisLoop);

    return;
}

void assignChron(void)
{
    int nThisLoop;
    int nChron = 0;
    KEYS_PP ppK;
                                        /* founders:  chronlogical no.  */
                                        /* assigned on first pass       */ 
    do {				/* non-founder: tests for ma  	*/
        nThisLoop = 0;			/* & pa already assigned        */
                                        /* chronological no.          	*/
        for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
            if (!(*ppK)->chron)
                if ((*ppK)->founder  ||
                     ((*(ppKeyTab + (*ppK)->ixMa - 1))->chron &&
                      (*(ppKeyTab + (*ppK)->ixPa - 1))->chron))
                {
                    (*ppK)->chron = ++nChron;
                    ++nThisLoop;
                }
    } while (nThisLoop);

    return;
}

int checkChron(void)
{
    int noChron = 0;
    int fNam = 0;
 
    KEYS_PP ppK;

    for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
        if (!(*ppK)->chron)
        {
            ++noChron;
            if (!fNam)
                fNam = (*ppK)->nam;
        }

    if (noChron == 0)
        return OK;

    if (noChron == 1)
        give_err(ERC_ch1, "checkChron", fNam);
    else
        give_err(ERC_chr, "checkChron", noChron, fNam);

    return !OK;
}

int newChron(void)
{

    KEYS_PP ppK;

    for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
        if ((*ppK)->ix != (*ppK)->chron)
            return TRUE;
    
    return FALSE;
}
