    
/*  functions are:
 *          assignGender()
 *          checkGender()
 */

#include "pedchk.h"

/*----------------------------------------------------------------------*/
/* assignGender():  sets mothers to females and fathers to males        */

void assignGender(void)
{
    KEYS_PP ppK = ppKeyTab;
    int i;
 
    if (SexOp == ASSIGN)
    {
        for (i = 0; i < nInd; ++i)	/* for each entry in key table	*/
        {
            if (!(*ppK)->founder)
            {
                (pPedDat + (*ppK)->ixPa - 1)->sex = MALE;
                (pPedDat + (*ppK)->ixMa - 1)->sex = FEMALE;
            }
            ++ppK;
        }
    }
    return; 
}

/*----------------------------------------------------------------------*/
/* checkGender():  checks parents for correct gender                    */
/*                 counts number of each gender                         */

int checkGender(void)
{
    KEYS_PP ppK = ppKeyTab;
    int i;
    int nMales, nFems, nUnis, nUnkn; 
    int nBadPar, namBadPar;

    if (SexOp == IGNORE)
    {
        fprintf(stdout, " Gender ignored\n\n");
        return OK;
    }
    if (SexOp == ASSIGN)
        fprintf(stdout, " Gender assigned\n\n");

    nMales = nFems = nUnis = nUnkn = nBadPar = 0;

    for (i = 0; i < nInd; ++i)
    {
        if ((pPedDat + (*ppK)->ix - 1)->sex == MALE)
            ++nMales;
        else if ((pPedDat + (*ppK)->ix - 1)->sex == FEMALE)
            ++nFems;
        else if ((pPedDat + (*ppK)->ix - 1)->sex == UNSEXED)
            ++nUnis;
        else
            ++nUnkn;

        if (!(*ppK)->founder)
            if ((pPedDat + (*ppK)->ixPa - 1)->sex != MALE
                 || (pPedDat + (*ppK)->ixMa - 1)->sex != FEMALE)
            {
                ++nBadPar;
                if (nBadPar == 1)
                    namBadPar = (*ppK)->nam; 
            }
        ++ppK;
    }
    fprintf(stdout, " Number of males:    %d\n", nMales);
    fprintf(stdout, " Number of females:  %d\n", nFems);
    if (nUnis)
        fprintf(stdout, " Number not sexed:   %d\n", nUnis);
    fprintf(stdout, " \n");
    if (nBadPar)
    {
        if (SexOp == ASSIGN)
            give_err(ERC_uas);

        if (nBadPar ==1)
            give_err(ERC_1bp, "checkGender", nBadPar, namBadPar);
        else
            give_err(ERC_bpr, "checkGender", nBadPar, namBadPar);
        return !OK;
    }
    return OK;
}

